----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:56:59 05/02/2010 
-- Design Name: 
-- Module Name:    CIS_ROM - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_TEXTIO.ALL; 
use std.textio.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity CIS_ROM is
	Generic (filename : string := string'("cis.rom"));
	Port (A : in  STD_LOGIC_VECTOR;
			D : out  STD_LOGIC_VECTOR (7 downto 0));
end CIS_ROM;

architecture Behavioral of CIS_ROM is

	constant size : integer := 2**A'length;
	
	type memory is array(0 to size-1) of std_logic_vector(7 downto 0);

	impure function readromfile(filename : string) return memory is
		file f : text open read_mode is filename;
		variable l : line;
		variable mem : memory;
	begin
		for i in 0 to size-1 loop
			mem(i) := (others => '-');
		end loop;
		
		for i in 0 to size-1 loop
			readline(f, l);
			exit when endfile(f);
			hread(l, mem(i));
		end loop;
		
		return mem;
	end function;

	signal rom : memory := readromfile(filename);

begin

	D <= rom(conv_integer(A));

end Behavioral;
