----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:01:31 05/03/2010 
-- Design Name: 
-- Module Name:    monostable_delay - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity monostable_delay is
	Port (clk : in  STD_LOGIC;
			value : in  STD_LOGIC_VECTOR;
			start : in  STD_LOGIC;
			state : out  STD_LOGIC);
end monostable_delay;

architecture Behavioral of monostable_delay is

	signal curval : std_logic_vector(value'range);
	signal counting : boolean;

begin

state <= '0' when counting and start = '1' else '1';

process (clk, start)
begin
	if (start = '0') then
		curval <= (others => '0');
		counting <= true;
	elsif (rising_edge(clk) and counting) then
		curval <= curval + 1;
		if (curval = value) then
			counting <= false;
		end if;
	end if;
end process;

end Behavioral;

